<?php

namespace Drupal\regex_field_validator\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin implementation of the 'regex_text_formatter' formatter.
 *
 * @FieldFormatter(
 *   id = "regex_text_formatter",
 *   label = @Translation("Regex validated text"),
 *   field_types = {
 *     "string",
 *     "string_long",
 *     "text",
 *     "text_long"
 *   }
 * )
 */
class RegexTextFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [];

    foreach ($items as $delta => $item) {
      $elements[$delta] = [
        '#type' => 'processed_text',
        '#text' => $item->value,
        '#format' => $item->format ?? NULL,
        '#langcode' => $langcode,
      ];
    }

    return $elements;
  }

}